﻿Imports System.IO
Imports Microsoft.VisualBasic.FileIO
Public Class frm_copias
    Private Sub btnDrive_Click(sender As Object, e As EventArgs) Handles btnDrive.Click
        If FolderBrowserDialog1.ShowDialog = DialogResult.OK Then
            Dim drive As String = FolderBrowserDialog1.SelectedPath
            If drive.Contains("\\") Then
                F0001("Drive inválido", 1) ' Função que visualiza mensagem
                txtCaminho.Text = ""
            Else
                txtCaminho.Text = drive
            End If
        End If
    End Sub
    Private Sub rdbCriar_CheckedChanged(sender As Object, e As EventArgs) Handles rdbCriar.CheckedChanged
        lblCaminho.Text = "Destino"
        txtCaminho.Text = ""
    End Sub
    Private Sub rdbRecuperar_CheckedChanged(sender As Object, e As EventArgs) Handles rdbRecuperar.CheckedChanged
        lblCaminho.Text = "Origem"
        txtCaminho.Text = ""
    End Sub
    Private Sub btnSaida_Click(sender As Object, e As EventArgs) Handles btnSaida.Click
        Me.Dispose()
        Me.Close()
    End Sub
    Private Sub btnConfirmar_Click(sender As Object, e As EventArgs) Handles btnConfirmar.Click
        If String.IsNullOrEmpty(txtCaminho.Text) Then
            F0001("Drive de " + Trim(lblCaminho.Text) + " por definir", 1)
        Else
            Dim driveC As New DriveInfo(txtCaminho.Text)
            If Not driveC.IsReady() Then
                F0001("Drive de " + Trim(lblCaminho.Text) + " não está disponível", 1)
            Else
                If rdbCriar.Checked Then
                    If Not FileSystem.DirectoryExists(txtCaminho.Text + "\FPM-CS") Then
                        FileSystem.CreateDirectory(txtCaminho.Text + "\FPM-CS") ' cria uma pasta na raíz para guardar as cópias
                    End If
                    Try
                        ' A variável "diretorio" corresponde ao diretório onde está a pasta "dados" que por sua vez contém a base de dados "FPMNtm"
                        Sql = "BACKUP DATABASE [" & diretorio & "\Dados\FPMNtm.MDF] TO DISK = N'" & diretorio & "\FPM-CS\FPMNtm.bak' WITH NOFORMAT, INIT,  NAME = N' FPMNtm-Full Database Backup', SKIP, NOREWIND, NOUNLOAD,  STATS = 10"
                        GravaDados(Sql)
                        If FileSystem.FileExists(diretorio & "\FPM-CS\FPMNtm.bak") Then
                            File.Copy(diretorio & "\FPM-CS\FPMNtm.bak", txtCaminho.Text & "FPM-CS\FPMNtm.bak", True)
                        End If
                        F0001("Cópias de Segurança efetuadas com sucesso !!!", 1)
                    Catch ex As Exception
                        F0001("Não foi possível efetuar as Cópias de Segurança." + Chr(13) + "Volte a repetir o procedimento", 1)
                    End Try
                Else
                    If Not FileSystem.FileExists(txtCaminho.Text + "FPM-CS\FPMNtm.bak") Then
                        F0001("Ficheiro de cópias inexistente", 1)
                    Else
                        Dim opc As Boolean
                        opc = F0001("A recuperação das cópias de segurança, só deve ser efetuada" + Chr(13) +
                                    "quando se verificar ter a base de dados corrompida,caso contrário," + Chr(13) +
                                    "todos os dados inseridos após a última cópia, serão eliminados." + Chr(13) +
                                    "Deseja confirmar a recuperação das mesmas?", 2)
                        If opc Then
                            File.Copy(txtCaminho.Text + "\FPM-CS\FPMNtm.bak", diretorio & "\FPM-CS\FPMNtm.bak", True)
                            Sql = "ALTER DATABASE [" & diretorio & "\Dados\FPMNtm.MDF] SET OFFLINE WITH ROLLBACK IMMEDIATE " & _
                                  "RESTORE DATABASE [" & diretorio & "\Dados\FPMNtm.MDF] FROM DISK = N'" & diretorio & "\FPM-CS\FPMNtm.bak' WITH REPLACE, STATS =5 " & _
                                  "ALTER DATABASE [" & diretorio & "\Dados\FPMNtm.MDF] SET ONLINE WITH ROLLBACK IMMEDIATE"
                            GravaDados(Sql)
                            F0001("Cópias de Segurança recuperadas com sucesso !!!", 1)
                        End If
                    End If
                End If
                Me.Dispose()
                Me.Close()
            End If
        End If
    End Sub

End Class